/*
 * $Log: hotload.c,v $
 * Revision 1.2  1996/12/23 22:32:46  jrh
 * Checkin for 1.62
 *
 * Revision 1.1  1995/09/16  17:22:18  root
 * Initial login under Linux
 *
 * Revision 1.3  1995/02/12  18:20:40  jrh
 * scripting beta
 *
 * Revision 1.2  1995/02/07  16:52:32  jrh
 * Don't do HOT_GO
 *
 * Revision 1.1  1994/05/30  21:44:23  jrh
 * Initial checkin at v1.33
 *
 */

static char rcsid[] ="$Id: hotload.c,v 1.2 1996/12/23 22:32:46 jrh Exp $";

#include <stdio.h>
#include <stdlib.h>
#include <qdos.h>
#include <ctype.h>
#include <string.h>
#include <qlib.h>
#include <things.h>
#include "defs.h"

typedef struct
{
    short key;
    short saved;
    HK_HEAD hd;
    char name[1];
}
HK_SAVE, *PHK_SAVE;

Prototype LoadKeys (unsigned int *);
Prototype RemoveKeys (unsigned int *);

static PLLIST pKList = NULL;

extern int AddStr (char, char **);

LoadKeys (unsigned int *mask)
{
    unsigned char text[132];
    int sts;
    int fd;
    unsigned char *s;
    short nkey = 0;
    
    if(*KeyFile == '\0')
    {
        return 0;
    }
    
    if ((fd = io_open (KeyFile,  0)) > 0)
    {
	while (io_fline (fd, -1, (char *) text, 128) > 0)
	{
	    unsigned char *p;

            s = (unsigned char *) stpblk ((char *) text);

            if (( p = (unsigned char *)strchr ((char *)s, '\n')))
	    {
	        *p = '\0';
	    }

	    if (*s && *s != '#')
	    {
		unsigned char pp[128];
		char *Ptr;

		if (*(s+1) == ',')
		{
		    short key, knum, lt;
		    PHK_ITEM h;
                    long dummy;
                    p = s+1;
		    *p++ = 0;
		    Ptr = (char *) pp;
		    ParseString ((char *) p, AddStr, 0, &Ptr);
		    *Ptr = 0;
		    if ((hk_fitem ((char *) s, &h, &key, &knum) == 0) &&
		            (*s == key))
		    {
			short n;
			PLLIST pl;
			PHK_SAVE ps;
			char txt[2];

			pl = (PLLIST) xmalloc (sizeof (LLIST));

			n = ((h->hd.str_len) + 1 & ~1) + sizeof (HK_HEAD);
                        if(h->hd.type == HKI_WKXF || h->hd.type == HKI_XFIL)
                        {
                            n += sizeof(HKH_GUARD);
                        }
			ps = (PHK_SAVE) xmalloc ((size_t) (n + 2 * sizeof (short)));
			ps->key = *s;
                        ps->saved = n;
			memcpy(&(ps->hd), h, n);
			pl->item = ps;
			ins_list (&pKList, pl, NULL);
			txt[0] = *s;
			txt[1] = 0;
			sts = hk_remov (txt);
		    }
		    else
                    {
			short ni, nb;
			short key = *s;

			ni = key / 32;
			nb = key % 32;

			mask[ni] |= (1 << nb);
		    }

		    lt = strlen ((char *) pp);
		    if ((h = (PHK_ITEM) mt_alchp ((long)(sizeof (HK_HEAD) + lt), &dummy, 0)) != NULL)
		    {
			h->hd.str_len = lt;
			h->hd.id = HK_ID;
			h->hd.type = HKI_STUF;
			h->hd.ptr = memcpy (h->name, pp, lt);
			sts = hk_set (*s, h, NULL);
			nkey++;
		    }
		}
		else if(isdigit(*s))
		{
		    short kval;
		    char *q, *t;
		    keymap_t *map;
		    int lt;
		    
		    kval = strtol((char *)s, &q, 10);
		    if(*q == '=')
		    {
			q++;
			if((t = strchr(q, '\t')))
			{
			    *t++ = 0;
			}
			Ptr = (char *) pp;
			ParseString ((char *) q, AddStr, 0, &Ptr);
			*Ptr = 0;
			if(map = xmalloc(sizeof(keymap_t)))
			{
			    map->next = QLmap;
			    QLmap = map;
			    lt = strlen((char *)pp)+1;
			    map->qlkey = kval;
			    map->seq[1] = map->seq[0] = xmalloc(lt+1);
			    strncpy(map->seq[1], (char *)pp, lt);
			    if(t)
			    {
				Ptr = (char *) pp;
				ParseString ((char *) t, AddStr, 0, &Ptr);
				*Ptr = 0;
				lt = strlen((char*)pp)+1;
				map->seq[0] = xmalloc(lt+1);
				strncpy(map->seq[0], (char *)pp, lt);
			    }
			}
		    }
		}
	    }
	}
	io_close (fd);
    }
    return nkey; 
}

RemoveKeys (unsigned int *mask)
{
    PLLIST pl;
    PHK_SAVE ps;
    PHK_ITEM h;
    unsigned char txt[2];
    unsigned char ch;
    unsigned int val;
    short i, j;
    int sts;

    txt[1] = 0;

    for (i = 0; i < 8; i++)
    {
	ch = i * 32;
	for (j = 0; j < 32; j++)
	{
	    val = 1 << j;
	    if ((mask[i] & val))
	    {
		txt[0] = ch + j;
		sts = hk_remov ((char *) txt);
	    }
	}
    }
    for (pl = pKList; pl; pl = pl->next)
    {
	short n;
        long d;
	ps = pl->item;
	txt[0] = ps->key;

	sts = hk_remov ((char *) txt);

	n = ps->saved;
	if ((h = (PHK_ITEM) mt_alchp (n, &d, 0)) != NULL)
	{
	    PHKH_GUARD gr;
	    
	    memcpy (h, &(ps->hd), n);
            if(h->hd.ptr)
            {
	        h->hd.ptr = h->name;
	    }
            if(h->hd.type == HKI_WKXF || h->hd.type == HKI_XFIL)
            {
                gr = (PHKH_GUARD)(h->name + ((h->hd.str_len) + 1 & ~1));
            }
            else
            {
                gr = NULL;
            }
	    sts = hk_set (ps->key, h, gr);
	}
    }
    FreeList (&pKList);
}
