/*
 * $Log: menu.c,v $
 * Revision 1.2  1995/11/12 15:29:37  root
 * No mesage !
 *
 * Revision 1.1  1995/09/16  17:22:18  root
 * Initial login under Linux
 *
 * Revision 1.9  1995/04/01  00:02:26  jrh
 * Fix resized menu redraw bug
 *
 * Revision 1.8  1995/03/31  21:21:23  jrh
 * Add User menu code and icon
 *
 * Revision 1.7  1995/03/31  12:21:52  jrh
 * Fix mallocs to use xmalloc
 *
 * Revision 1.6  1995/03/24  16:29:31  jrh
 * Menu code (one less pointer)
 *
 * Revision 1.5  1995/03/18  12:15:37  jrh
 * C68 v4.5
 *
 * Revision 1.4  1995/03/12  23:00:08  jrh
 * scripting
 *
 * Revision 1.3  1994/12/15  21:31:12  jrh
 * variable menus
 *
 * Revision 1.2  1994/05/31  22:19:55  jrh
 * c68 v4.13c fixes
 *
 * Revision 1.1  1994/05/30  21:43:41  jrh
 * Initial checkin at v1.33
 *
 */

static char rcsid[] ="$Id: menu.c,v 1.2 1995/11/12 15:29:37 root Exp $";

#include <stdio.h>
#include <qdos.h>
#include <qptr.h>

#include "defs.h"

#define RETITM  39

Prototype int menu (struct WM_wwork *, char *, LLIST **, int, int, int, int, int, struct WM_litm *, int);

static long MACT (struct WM_wwork *, struct WM_menw *, char *, short, short);
static long MDRAW (struct WM_wwork *, struct WM_menw *);

static struct WM_action mdraw = {JSR, wm_drwaw, MDRAW};
static struct WM_action mact = {JSR, wm_actme, MACT};

#define MAX_SECT    1
#define MAX_YSIZE   120

extern char mono;

static struct WM_info d_info[2] =	/* information objects */
{
    {10, 10,			/* xsize, ysize         size */
     2, 0,			/* xorg, yorg           and origin */
     TYP_TEXT, 0,		/* type, spare          item type */
     {1, 0, 0},			/* ink, cwid, chgt      character attributes */
     NULL},			/* *pobj                pointer to object */
    {-1, -1}
};

static struct WM_infw d_infw[3] =
{
    {0, 14,			/* xsize, ysize         size */
     0, 0,			/* xorg, yorg           and origin */
     0,				/* flag                 no clear + shadow */
     0, 0, 84,			/* borw, borc, papr     border width/clr, paper */
     NULL},			/* *pobj                pointer to object list */

    {10, 10,			/* xsize, ysize         size */
     4, 2,			/* xorg, yorg           and origin */
     0,				/* flag                 no clear + shadow */
     0, 0, 7,			/* borw, borc, papr     border width/clr, paper */
     NULL},			/* *pobj                pointer to object list */
    {-1, -1}
};


static struct WM_menw d_mw =	/* menu window */
{
    0, 0,			/* xsize, ysize         size */
    2, 14,			/* xorg, yorg           and origin */
    0,				/* flag                 no clear + shadow */
    1, 4, 0,			/* borw, borc, papr     border width/clr, paper */
    NULL,			/* *pspr                pointer to sprite */
    &mdraw,			/* *draw                draw routine */
    wm__mhit,			/* *hit                 hit routine */
    wm__pnsc,			/* *ctrl                control routine */
    0, 0,			/* nxsc, nysc           max x,y sections */
    0, 0, 0,			/* skey, 2 spare        selection keystroke */
    NULL,			/* *pwcb            part window ctrl block */
    0, 0, 0, 0, 0, 0, NULL, NULL,	/* 6 short 2 pointer zero */
    2, 0, 7,			/* psac, psbc, pssc arrow/bar clrs */
    NULL,			/* *pwcb            part window ctrl block */
    0, 0, 0, 0, 0, 0, NULL, NULL,	/* 6 short 2 pointer zero */
    2, 0, 7,			/* psac, psbc, pssc arrow/bar clrs */
    NULL,			/* *mstt                menu status area */
    1, 2,			/* curw, curc           current item width/clr */
    0, 2, NULL, NULL,		/* uback, uink, *ublob, *upatt unavail */
    0, 7, NULL, NULL,		/* aback, aink, *ablob, *apatt  avail */
    2, 7, NULL, NULL,		/* sback, sink, *sblob, *spatt selected */
    1, 0,			/* ncol, nrow           columns and rows */
    0, 0,			/* xoff, yoff           window offset */
    {0,0},			/* -xsize, -xspce     or *xspc spacing list */
    {-10,-12},			/* -ysize, -yspce     or *yspc spacing list */
    NULL, NULL,			/* *xind, *yind         not implemented */
    NULL			/* *rowl                row list */
};

static struct WM_wwork d_ww =	/* window working definition */
{
    NULL,			/* *wstat;              pointer to status area */
    NULL,			/* *wscale              this was pointer to WDEF */
    0,				/* chid                 channel ID */
    NULL,			/* *pprec               pointer to pointer record */
    0,				/* psave                pointer position saved */
    0, 0, 0, 0,			/* 4 zero */
    NULL,			/* *splst               pointer to sprite list */
    0, 0,			/* xsize, ysize will need changing */
    0, 0,			/* xorg, yorg           and origin */
    NO_WCLEAR + 2,		/* flag                 no clear + shadow */
    1, 4, 84,			/* borw, borc, papr     border width/clr, paper */
    NULL,			/* *sprite              pointer to sprite */
    1, 0,			/* curw, curc           current item width/clr */
    7, 4, NULL, NULL,		/* uback, uink, *ublob, *upatt  unavail */
    7, 0, NULL, NULL,		/* aback, aink, *ablob, *apatt  avail */
    4, 0, NULL, NULL,		/* sback, sink, *sblob, *spatt  selected */
    NULL,			/* *help */
    2, 1, NULL,			/* ninfo, ninob, *pinfo info winds */
    0, NULL,			/* nlitm, *plitm        loose items */
    1, NULL			/* nappl  *pappl        appl winds */
};

extern struct WM_wwork *Main_ww;

int menu (struct WM_wwork *wwk, char *prompt, LLIST **MList, int icount,
                int xoff, int yoff, int xsize, int ysize, struct WM_litm *plitem,
                int nlitem)
{

    short pr_w = 0;
    struct WM_wstat ws;
    struct WM_info info[2];
    struct WM_infw infw[3];
    struct WM_menw mw;
    struct WM_appl appl[2];
    struct WM_wwork ww;
    struct WM_litm *ppl;
    short last;
    int rval;
    short yf,flg;
    int ns;
    WM_PWCB (2) pwcy;
    QD_text_t *ptitle;

    flg = 0;

    ns = (1+nlitem) * sizeof(struct WM_litm);
    ppl = xmalloc(ns);

    memcpy(ppl, plitem, ns);

    memset (&pwcy, '\0', sizeof (pwcy));
    memcpy (info, d_info, sizeof (d_info));

    memcpy (infw, d_infw, sizeof (d_infw));
    infw[1].pobl = info;

    memcpy (&mw, &d_mw, sizeof (d_mw));
    appl[0].pappw = (struct WM_appw *) &mw;
    appl[1].pappw = NULL;

    memcpy (&ww, &d_ww, sizeof (d_ww));
    memset (&ws, '\0', sizeof (ws));
    ws.litem[RETITM] = 0;
    ww.pappl = ww.splst = appl;
    ww.pinfo = infw;
    ww.plitm = ppl;
    ww.nlitm = nlitem;

    ws.wmode = FORM_QL4;
    ws.wwork = &ww;		/* cross references */
    ww.wstat = &ws;
    
    if (ysize == 0)
    {
        ysize = icount * 12;
    }

    if(ysize > (wwk->ysize - 4) - 30)
    {
        ysize = 12*(((wwk->ysize - 4) - 30)/12) ;
        flg = 1;
        yoff = 0;
    }

    if(xsize == 0)
    {
        xsize = (((PMDEF) (*MList)->item)->qtext->len) * 6 + 12 +flg*8;
    }

    if(xsize > (wwk->xsize-12))
    {
        xsize = (wwk->xsize-12);
        xoff = 0;
    }

    pr_w = strlen(prompt);
    ptitle = xmalloc(pr_w + 8);
    ptitle->len = pr_w;
    memcpy(ptitle->chrs, prompt, pr_w);

    pr_w = (pr_w + 1) * 6;

    info[0].pobj = ptitle;
    info[0].xsize = pr_w - 6;	/* String length */
    infw[0].xsize = xsize;
    infw[1].xsize = pr_w;	/* outer wight window */

    last = nlitem - 1;
    (ppl+last)->xorg = xsize - (ppl+last)->xsize - 4;

#if 0
    {
        char txt[80];
        sprintf(txt,"Last is %d %d %d", last, (ppl+last)->xorg, plitem->xsize);
        menu_choice (wwk, txt, 1, 0, "OK");
    }
#endif

    LoadMenu (&mw, *MList, &mact);

    ww.xsize = xsize;
    mw.xsize = xsize - 4;

    mw.ysize = ysize;
    ww.ysize = 15 + mw.ysize;
    mw.nysc = MAX_SECT;
    mw.ypwcb = (struct WM_pwcb *) &pwcy;
    ww.xorg = 4;
    ww.yorg = 15 + 8;
    
    ws.citem = -1;		/* no current item  */
    ws.ciact = NULL;		/* or current item routine */

    if(mono)
    {
        mw.ypsac = 7;
        mw.sback = 7;
        mw.sink = 0;
        mw.curc = 7;
        ww.borc = mw.borc = 7;        
        ww.uink = 0;            
        ww.sback =7;
        infw[0].papr = ww.papr = 127;
    }

    if(yoff == 0)
    {
        yf = (wwk->ysize - 4 - ww.ysize)/2;
        if(yf + ww.ysize > Main_ww->ysize - 14)
        {
            yf = Main_ww->ysize - 14 - ww.ysize;
        }
    }
    else
    {
        yf = yoff;
    }
    
    wm_pulld (&ww, wwk->xorg + xoff, wwk->yorg + yf);	/* pull down */
    wm_wdraw (&ww);

    while (!wm_rptr (&ww))
    {
	if (ws.evnt & PT_CAN)
	    break;
	if (ws.evnt & PT_WMOVE)
	{
	    menu_rems (&mw);
	    LoadMenu (&mw, *MList, &mact);
	    wm_swapp (&ww, 0, -1);
	    sd_clear (ww.chid, -1);
	    MDRAW (&ww, &mw);
	}
    }

    rval = ws.litem[RETITM];

    if(mw.rowl)
    {
        xfree (mw.rowl);
    }

    mw.rowl = NULL;
    wm_cluns (&ww);		/* throw it away */

    xfree(ppl);
    xfree(ptitle);

    return rval;
}

static long MDRAW (struct WM_wwork *wwk, struct WM_menw *mw)
{

    menu_chks (mw);
    wm_index (wwk, (struct WM_swdef *) mw);
    wm_mdraw (wwk, (struct WM_swdef *) mw, 0);
}

static long MACT (struct WM_wwork *wwk, struct WM_menw *mw, char *mst, short col, short row)
{
    struct WM_mobj *mobj;

    mobj = mw->rowl[row].rows;	/* current menu object */
    wwk->wstat->litem[RETITM] = mobj->item;
    return PT__CAN;
}
