/*
 * $Log: menu_bframe.c,v $
 * Revision 1.2  1996/12/23 22:32:47  jrh
 * Checkin for 1.62
 *
 * Revision 1.1  1995/09/16  17:22:18  root
 * Initial login under Linux
 *
 * Revision 1.4  1995/03/18  12:13:49  jrh
 * C68 v4.5
 *
 * Revision 1.3  1994/07/09  15:34:29  jrh
 * Do button frame correctly
 *
 * Revision 1.2  1994/05/31  22:19:55  jrh
 * c68 v41.3c fixes
 *
 * Revision 1.1  1994/05/30  21:43:48  jrh
 * Initial checkin at v1.33
 *
 */

static char rcsid[] ="$Id: menu_bframe.c,v 1.2 1996/12/23 22:32:47 jrh Exp $";

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <qdos.h>
#include <qptr.h>

#include "defs.h"
#include "xprmsg.h"


static long ASWAKE (struct WM_wwork *, struct WM_litm *, struct WM_wstat *,
            short, short, short, short);

static struct WM_action aswake = {JSR, wm_actli, ASWAKE};

Prototype void menu_button (struct WM_wwork *, char *, PXPRTHG);

extern short iconic,SrvCmd;
	    
extern void XAction(struct WM_wwork *);
extern void CheckServerStuff(struct WM_wwork *);

void menu_button (struct WM_wwork *wwk, char *title, PXPRTHG pXB)
{
    short sleep_wid;
    
#define ti_max 32
    static QD_TEXT (ti_max) _title = {0};

    static struct WM_wstat ws = {0};	/* this time ws is initialised in code */

    static struct WM_litm litm[1 + 1] =	/* loose item */
    {
	{12, 10,		/* xsize, ysize         size */
	 2, 1,			/* xorg, yorg           and origin */
	 0, 0,			/* xjst, yjst           justification */
	 TYP_TEXT, K_WAKE,	/* type, skey           type and select key */
	 &_title,		/* *pobj                pointer to object */
	 LIT_MOVE,		/* item                 item number */
	 &aswake},		/* *pact                pointer to action */

	{-1}			/* end of array */
    };

    static struct WM_wwork ww =	/* window working definition */
    {
	NULL,			/* *wstat;              pointer to status area */
	NULL,			/* *wscale              this was pointer to WDEF */
	0,			/* chid                 channel ID */
	NULL,			/* *pprec               pointer to pointer record */
	0,			/* psave                pointer position saved */
	0, 0, 0, 0,		/* 4 zero */
	NULL,			/* *splst               pointer to sprite list */

	16, 12,			/* xsize, ysize         size */
	12, 8,			/* xorg, yorg           and origin */
	0,			/* flag                 no clear + shadow */
	1, CL_BBORD, CL_MBACK,	/* borw, borc, papr     border width/clr, paper */
	NULL,			/* *sprite              pointer to sprite */

	1, CL_MHIGH,		/* curw, curc           current item width/clr */

	CL_MPUNAV, CL_MIUNAV, NULL, NULL,	/* uback, uink, *ublob, *upatt  unavail */
	CL_BPAVBL, CL_BIAVBL, NULL, NULL,	/* aback, aink, *ablob, *apatt  avail */
	CL_BPSLCT, CL_BISLCT, NULL, NULL,	/* sback, sink, *sblob, *spatt  selected */

	NULL,			/* *help */

	0, 0, NULL,		/* ninfo, ninob, *pinfo info winds */
	1, litm,		/* nlitm, *plitm        loose items */
	0, NULL			/* nappl  *pappl        appl winds */
    };

static struct WM_appw aw0 =	/* application sub-window */
{
    0, 10,			/* xsize, ysize         size */
    2, 1,			/* xorg, yorg           and origin */
    NO_WCLEAR,		        /* flag                 no clear + shadow */
    0, 0, 7,			/* borw, borc, papr     border width/clr, paper */
    NULL,			/* *pspr                pointer to sprite */
    NULL,			/* *draw                draw routine */
    NULL,			/* *hit                 hit routine */
    NULL,			/* *ctrl                control routine */
    0, 0,			/* nxsc, nysc           max x,y sections */
    0, 0, 0,			/* skey, 2 spare        selection keystroke */
    NULL,			/* *pwcb            part window ctrl block */
    0, 0, 0, 0, 0, 0, NULL, NULL,	/* 6 short 2 pointer zero */
    CL_WRROW, CL_WBARB, CL_WBARS,	/* psac, psbc, pssc arrow/bar clrs */
    NULL,			/* *pwcb            part window ctrl block */
    0, 0, 0, 0, 0, 0, NULL, NULL,	/* 6 short 2 pointer zero */
    CL_WRROW, CL_WBARB, CL_WBARS,	/* psac, psbc, pssc arrow/bar clrs */
    NULL
};

static struct WM_appl appl[2] =
{
    &aw0, NULL
};
        
    QAwake = 0;

    sd_curs(pChId, -1);
    mt_susjb (ClkPID, -1, NULL);
    
    ws.wwork = &ww;		/* cross references */
    ww.wstat = &ws;
    ww.chid = wwk->chid;	        /* copy channel ID */
    ww.flag = 0;
    ws.wmode = FORM_QL4;

    QD_STXT (_title, title, ti_max);	/* title string */

    sleep_wid = (((_title.len * 6) + 3) & 0xfffc);	/* round up to multiple of 4 */

    ww.xsize = sleep_wid + 4;	/* allow for loose item border */
    ww.xorg = sleep_wid - 4;	/* pointer here */
    ww.yorg = 9;

    litm[0].xsize = sleep_wid;	/* set item size */
    ws.litem[0] = 0;		/* and status */

    ws.citem = -1;		/* no current item  */
    ws.ciact = NULL;		/* or current item routine */

    if(!iconic)
    {
	wm_unset (wwk);		/* unset old definition */
    }

    if(pXB)
    {
        ww.nappl = 1;
        ww.pappl = appl;
        aw0.xsize = sleep_wid;
        aw0.pstat = (char *) pXB;
    }
    else
    {
        ww.nappl = 0;
        ww.pappl = NULL;
    }
    if (bt_prpos (&ww))
    {
	ww.flag = 1;		/* ... no, use shadow */
	wm_prpos (&ww, DEFXY);
    }				/*     and position at pointer */

    wm_wdraw (&ww);		/* and draw */

    if(pXB)
    {
        wm_swdef(&ww, &aw0, pXB->chid);
        sd_setin(pXB->chid, -1, 0);
        sd_setst(pXB->chid, -1, 7);
        pXB->icon = 1;
    }
    
    while (!wm_rptr (&ww))
    {
	if (ws.evnt & PT_WAKE)
	{
	    if(iconic)
	    {
		if(SrvCmd)
		{
		    CheckServerStuff(&ww);
		}
		if(DO_XPR)
		{
		    XAction(&ww);
		}
	    }
	    else
	    {
		break;
	    }
	}
    }

    if(pXB)
    {
        pXB->icon = 2;
    }
    wm_unset (&ww);		/* unset button */

    if (!ww.flag)
    {
	bt_free ();
    }
    wwk->xorg = wwk->wstat->ptpsx - wwk->xorg;
    wwk->yorg = wwk->wstat->ptpsy - wwk->yorg;	/* set "origin" to window rel pos */

    wwk->wstat->litem[LIT_WATCH] = WSI_MKAV;
    wwk->wstat->litem[LIT_QUIT] = WSI_MKUN;
    wm_prpos (wwk, wwk->wstat->ptpsx, wwk->wstat->ptpsy);	/* old window position */
    wm_wdraw (wwk);		/* and draw */
    wwk->wstat->litem[LIT_WATCH] = WSI_UNAV;
    wwk->wstat->litem[LIT_QUIT] = WSI_AVBL;
    mt_reljb (ClkPID);
    QAwake = 2;
}

static long ASWAKE (struct WM_wwork *wwk, struct WM_litm *li, struct WM_wstat *wst, short xpos, short ypos, short key, short event)
{
    if (event)
    {
        if(wwk->nappl)
        {
            ((PXPRTHG)wwk->pappl->pappw->pstat)->icon = 2;
        }
	lit_reset (wwk, LIT_MOVE);
	return PT__WAKE;	/* convert DO to WAKE */
    }
    if (wwk->flag)
    {
        short dx,dy;
        PXPRTHG pXB;        
        if(wwk->nappl)
        {
            pXB = (PXPRTHG)wwk->pappl->pappw->pstat;
            pXB->icon = 2;
        }
        wwk->wstat->evnt |= PT_WMOVE;	/* set event bit for wm_chwin */
        wm_chwin (wwk, &dx, &dy);	/* move window */

        if(wwk->nappl)
        {
            wm_swdef(wwk, wwk->pappl->pappw, pXB->chid);
            sd_setin(pXB->chid, -1, 0);
            sd_setst(pXB->chid, -1, 7);
            pXB->icon = 1;
        }

    }
    return lit_reset (wwk, LIT_MOVE);	/* otherwise reset and return */
}


