/*
 * $Log: qem.h,v $
 * Revision 1.10  1998/01/18 18:54:57  jrh
 * for 1.63 release
 *
 * Revision 1.9  1997/08/23 21:11:08  jrh
 * pre config removal
 *
 * Revision 1.8  1997/04/13 16:54:42  jrh
 * cursor and console changes
 *
 * Revision 1.7  1996/12/23 22:32:55  jrh
 * Checkin for 1.62
 *
 * Revision 1.6  1996/07/09  12:25:57  jrh
 * post fsel (1.60)
 *
 * Revision 1.5  1996/07/09  09:26:14  jrh
 * pre file sel (1.599)
 *
 * Revision 1.4  1995/12/30  18:28:09  root
 * For v1.57 (QXL baud, SH status, CSM crash)
 *
 * Revision 1.3  1995/11/26  14:29:04  root
 * System specific changes
 *
 * Revision 1.2  1995/11/12  15:29:37  root
 * Baud rates for QXL etc
 *
 * Revision 1.1  1995/09/16  17:22:18  root
 * Initial login under Linux
 *
 * Revision 1.8  1995/05/31  17:05:26  jrh
 * No CR option and new XPR (nothing)
 *
 * Revision 1.7  1995/03/24  16:29:31  jrh
 * *** empty log message ***
 *
 * Revision 1.6  1995/03/18  12:34:53  jrh
 * preparation for Viewdata
 *
 * Revision 1.5  1995/03/13  22:13:34  jrh
 * Added init/exit scripting
 *
 * Revision 1.4  1995/03/12  23:00:08  jrh
 * scripting
 *
 * Revision 1.3  1994/12/15  21:34:58  jrh
 * variable changes
 *
 * Revision 1.2  1994/06/05  19:10:16  jrh
 * Added VT100/Vt102 options
 *
 * Revision 1.1  1994/05/30  21:44:17  jrh
 * Initial checkin at v1.33
 *
 * $Id: qem.h,v 1.10 1998/01/18 18:54:57 jrh Exp $
 */
#ifndef _QEM_H_
#include "ql.h"
#define OK 1
#define FAIL 0

#define NORM 1
#define APP 0

#define  VT52       0x01
#define  VT100      0x02
#define  VT102      0x04
#define  ANSI1	    0x08
#define  ANSI2	    0x10
#define  ANSI3      0x20
#define  ANSI4      0x40
#define  VIEWD      0x80

#define  DECVT      0x06        /* VT100ish */
#define  ANSI_M	    0x78	/* Mask of ANSI-ness */
#define  VT100_M    0x7e	/* Mask of VT- ness */
#define  ANSI_BOLD  0x60	/* ANSI Bold modes */
#define  ANSI_8COL  0x68	/* ANSI 8 colour modes */

#define  EOLLF    0
#define  EOLCR    1
#define  EOLCRLF  2

#define  QEXIT    254

#define  KP0      144
#define  KP1      145
#define  KP2      146
#define  KP3      147
#define  KP4      148
#define  KP5      149
#define  KP6      150
#define  KP7      151
#define  KP8      152
#define  KP9      153

#define  KPPLUS   157
#define  KPPLUS1  139
#define  KPMINUS  141
#define  KPCOMMA  140
#define  KPDOT    142
#define  KPENTER  143

#define SNORM  0
#define SESC   1
#define SESCNO 2
#define SESCGx 3
#define SESCPM 4
#define SESCP1 5
#define SESCP2 6
#define SESCEX 7
#define SUSC   8

#define VTFONT    1
#define VIEWCHAR  2
#define VIEWGRAF  3

#define ASCCAP    1
#define HEXCAP    2

#define  TOGGLE   0xff
#define  EDIT     0xfe

#define  XEDIT    0
#define  QEDIT    1

#define  Q_DIAL   3
#define  Q_ONLINE 7
#define  Q_IDLE   0
#define  Q_WAIT	  -1
#define  Q_DONE   -2

#define  C_TEXT   0
#define  C_GRAF   1

#define  XS_WAIT  20
#define  QM_WAIT  4

#define XSETUP  1
#define XSEND   2
#define XRECV   3
#define XCLEAN  4

#define SEND 3
#define RECEIVE 4

#define SF1 0xea
#define SF2 0xee
#define SF3 0xf2
#define SF4 0xf6
#define SF5 0xfa

typedef struct
{
    void *Text;
    int value;
}
OPTLIST, *POPTLIST;

typedef struct
{
    void *Title;
    void *list;
    UCHAR current;
    UCHAR Change;
    UCHAR defval;
    UCHAR type;
    UCHAR xp;
    UCHAR yp;
}
EDITLIST, *PEDITLIST;

typedef struct
{
    UCHAR ch;
    char *pText[2];
}
XLATES, *PXLATES;

extern char QeM_Dat[];

typedef struct
{
    int Sprio;
    int Qprio;
    int Swait;
    int Qwait;
    int Zprio;
}
TUNEBLK, *PTUNEBLK;

typedef struct
{
    int pClId;
    int qClock;
    int qState;
    int qJobId;
    int dState;
    int dTry;
    int dWait;
    int dTime;
}
CLKBLK, *PCLKBLK;

typedef struct
{
    int pSerId;                                     /* 00 */
    int Pid;                                        /* 04 */
    int (*ReadQue) (int, char *, int, int *);       /* 08 */
    int (*SendChr) (char);                          /* 12 */
    int (*SendStr) (char *);                        /* 16 */
    int (*SendQCs) (char *, int);                   /* 20 */
    short bFlow;            /* 24 */
    short Wait;             /* 26 */
    short Ident;            /* 28 */
    char  spare;             /* 30 */
    char  QCIS;             /* 31 */
    char QErr;              /* 32 */
    char z1;                /* 33 */
    char z2;                /* 34 */
    char z3;                /* 35 */
    int xon;                /* 36 */
    int xoff;               /* 40 */
    int Size;               /* 44 */
    int Count;              /* 48 */
    char *Buff;             /* 52 */
    char *Addr;             /* 56 */
    int  SerSts;            /* 60 */
}
SERBLK, *PSERBLK;

typedef struct
{
    char *FileName;
    char *ComStr;
    char *InFile;
    int inflag;
    char *OuFile;
    int ouid;
    int JobId;
    int serr;
    unsigned char Prio;
    unsigned char Wait;
} SJOB, *PSJOB;

typedef union {
    char txt[4];
    long x;
 } ALIGN;

typedef struct _keys_ keymap_t;

struct _keys_
{
    keymap_t *next;
    char *seq[2];
    short qlkey;
};

typedef struct lemt
{
    struct lemt *next;
    char * fpos;
} LEMT, *PLEMT;

typedef struct 
{
    char *name;
    int chid;
    char *buf;
    int mem;
    int size;
    int pos;
    int max;
    int revid;
    int child;
    int iline;
    PLEMT pHead;
    int NLine;
    int TopL;
    int BotL;
    int maxline;
    char *RevPtr;
    int msize;
    short lx;
    short ly;
    short DoAct;
    short maxw;
    char wrap;
    char new;
    char Quit;
    char wake;
#ifdef SIGS
    char flag;
#endif
} CAPDEF_t;

extern spawn(SJOB *);

GLOBAL CAPDEF_t Cap;
GLOBAL CAPDEF_t Xfr;

GLOBAL PCLKBLK qC;
GLOBAL PSERBLK pS;
GLOBAL int pChId;

GLOBAL int pSendId;
GLOBAL int pStId;
GLOBAL int pFileId;
GLOBAL int XPRWin;
GLOBAL int fErr;
GLOBAL int lStatus;
GLOBAL int XPRStatus;
GLOBAL int Xoption;
GLOBAL int XPRPid;
GLOBAL int pDummy;
GLOBAL int jScroll;
GLOBAL short Xpos, Ypos;
GLOBAL short wRep;
GLOBAL unsigned short wBaud;
GLOBAL unsigned short ExBaud;
GLOBAL UCHAR bSave;
GLOBAL UCHAR bConf;
GLOBAL UCHAR bShutDown;
GLOBAL UCHAR bEmulation;
GLOBAL UCHAR bRXEOL;
GLOBAL UCHAR bTXEOL;
GLOBAL UCHAR bQ5;
GLOBAL UCHAR bErrMsg;
GLOBAL UCHAR bMaxChar;
GLOBAL UCHAR bMaxLine;
GLOBAL UCHAR QPtr;
GLOBAL UCHAR bLocal;
GLOBAL UCHAR bShowCSI;
GLOBAL UCHAR xicon;
GLOBAL short CDelay;

GLOBAL char bDelChar;
GLOBAL char bCapture;
GLOBAL char nCapture;
GLOBAL char ScreenMode;
GLOBAL char bBeep;

GLOBAL char *pCurrFile;

GLOBAL char *pAnswer;
GLOBAL char *pSerial;
GLOBAL UCHAR fCol;
GLOBAL UCHAR bCol;
GLOBAL UCHAR bVTKmode;
GLOBAL UCHAR sState;
GLOBAL UCHAR lastpr;
GLOBAL UCHAR lastch;
GLOBAL char *pEscBuf;
GLOBAL char bEnq;
GLOBAL char vtMode;
GLOBAL char bCtrl;
GLOBAL char sCount;
GLOBAL char bInsert;
GLOBAL char bWrap;
GLOBAL char csr;
GLOBAL char DoDialJob;
GLOBAL char QAwake;
GLOBAL char bVTPad;
GLOBAL char bWakeDraw;
GLOBAL char bRevWake;
GLOBAL char saveCR;
GLOBAL char key7;

GLOBAL char *sbuf, *sptr;
GLOBAL int ssize;

GLOBAL int SerJID;
GLOBAL int ClkPID;
GLOBAL int Blocked;
GLOBAL int QTpid;
GLOBAL int DO_XPR;
GLOBAL unsigned short wwFlag;
GLOBAL short minnie;
GLOBAL char *ExitParams;
GLOBAL char lbaud;
GLOBAL UCHAR specbaud;
GLOBAL UCHAR osid;
GLOBAL char *osnam;
GLOBAL short sHermes;
GLOBAL keymap_t *QLmap;
GLOBAL short okey, oflag, zquiet;


extern char mono;
extern char hflag;
extern unsigned short dbflag;
extern short scrX;
extern short scrY;
extern short maxser;
extern short useFS;
extern short conf1;
extern short conf2;

extern TUNEBLK QT;
extern short Iserve;

#define SOUND_OFF       SoundOff(3)
#define SOUND_OFF_MORE  SoundOff(5)

extern OPTLIST stWrap[];
extern OPTLIST stVt[];
extern OPTLIST stPort[];
extern OPTLIST stParity[];
extern OPTLIST stShake[];
extern OPTLIST stProt[];
extern OPTLIST stSpeed[];
extern OPTLIST stExSpeed[];
extern OPTLIST stMode[];
extern OPTLIST stCRLF[];
extern OPTLIST stSwap[];
extern OPTLIST stYesNo[];
extern OPTLIST stCtrl[];
extern OPTLIST stDelC[];
extern OPTLIST stArrows[];
extern OPTLIST stXPR[];
extern OPTLIST stDoLog[];
extern OPTLIST stRedraw[];

extern EDITLIST Setups[];
extern EDITLIST DialOpts[];
extern EDITLIST ModemSetups[];
extern EDITLIST FileSetups[];
extern EDITLIST KeyOpts[];

#include "qtpi_version.h"
#define _QEM_H_
#endif

