#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <qdos.h>
#include <things.h>
#include <unistd.h>
#include <sys/stat.h>

#ifndef TEST
#include <qptr.h>
#include "qem.h"

typedef struct
{
    unsigned short attr;
    unsigned short info;
    void *ptr;
} MENUP;

typedef struct
{
    MENUP   mennm;
    MENUP   defnm;
    MENUP   dirnm;
    MENUP   extnm;
    long    size;
    long    xpos;
    long    ypos;
    long    manic;
    long    filec;
    MENUP   fname;
} MENUFS;

#define THP_UPD     0xe000
#define THP_CALL    0xc000
#define THP_RET     0xa000
#define THP_PTR     0x8000
#define THP_OPT     0x1000

#define THP_CHAR    0x0004
#define THP_UBYT    0x0008
#define THP_SBYT    0x000a
#define THP_UWRD    0x0010
#define THP_SWRD    0x0012
#define THP_ULNG    0x0020
#define THP_SLNG    0x0022
#define THP_FP8     0x0042
#define THP_STR     0x0100
#define THP_SSTR    0x0200


int GetFileName (struct WM_wwork *, char *, char *, int, int, int);

#define MOVEIN(s, t) s.len = strlen(t); strcpy((char *)s.chrs, t)

static void restore (char *buf, struct QD_text *qdt)
{
    strncpy (buf, (char *) qdt->chrs, qdt->len);
    *(buf + qdt->len) = '\0';
}

 
static const unsigned short use_thg[] =
{0x206F, 0x0004,		/*      move.l  4(sp),a0 */
 0x226F, 0x0008,		/*      move.l  8(sp),a1 */
 0x4E90,			/*      jsr     (a0)     */
 0x4E75};			/*      rts              */


int UseMenus (void)
{
    static ALIGN fsel = {"FSEL"};
    long vers;
    void *ps = NULL;
    return (int) sms_uthg ("Menus", -1, -1, (long *) &fsel, NULL, &vers, &ps);
}

void HoldSiblings(void);
void RelSiblings(void);
#else
char *_endmsg = NULL;
#endif

/* Seems quite apt as the Wales' get the degree nisi */

static void SplitUp(char *name, char *dirn, char *ext)
{
    char path[40];
    char c, *d = NULL, *p, *s, *r;
    struct stat st;
    
    p = strcpy(path, name);

    *dirn = *ext = 0;
    d = (p+strlen(p)-1);

    if((stat(path, &st) == 0) && (st.st_mode & S_IFDIR))
    {
	strcpy(dirn, name);
	return;
    }
    
    for(d = r = p; (s = strchr(r, '_')); r = s+1)
    {
	int res;
	s++;
	
	c = *s;
	*s = 0;
	res = ((stat(path, &st) == 0) && (st.st_mode & S_IFDIR));
	if(res)
	{
	    d = s;
	    strcpy(dirn, path);
	}
	*s = c;
    }
    if(r = strrchr(d, '_'))
    {
	strcpy(ext, r);
    }
    else
    {
	if(access(name, F_OK) == 0)
	{
	    strcpy(dirn, name);/* all dir */
	    *ext = 0;
	}
    }

}
#ifndef TEST
int GetMenuFile (char *prompt, char *dirs, char *buf)
{
    int i = -1;
    char *p;

    THING_HEADER_EXT *pThing;

    static QD_TEXT (39) menustr;
    static QD_TEXT (39) basestr;
    static QD_TEXT (39) direstr;
    static QD_TEXT (39) rsltstr;
    static QD_TEXT (39) extstr;

    static MENUFS s =
    {
	{THP_CALL | THP_OPT | THP_STR, 0, &menustr},
	{THP_CALL | THP_OPT | THP_STR, 0, &basestr},
	{THP_CALL | THP_OPT | THP_STR | THP_UPD, 0, &direstr},
	{THP_CALL | THP_OPT | THP_STR, 0, &extstr},
	0,
	0,
	0,
	-1,
	-1,
	{THP_RET | THP_STR, 39, &rsltstr}
    };


    MOVEIN (menustr, prompt);
    MOVEIN (basestr, buf);  
    MOVEIN (extstr, "");
#if 0    
    if(p = strchr(dirs, '_'))
    {
        char *q;
        char c;

	p++;
	c = *p;
	*p = '\0';
	MOVEIN (direstr, dirs);
	*p = c;
    }        
    else
    {
	char def[40];
	getcwd(def, 39);
	MOVEIN (direstr, def);
    }
#else
#endif
    if(dirs && *dirs)
    {
	SplitUp(dirs, (char *) direstr.chrs, (char *) extstr.chrs);
	direstr.len = strlen((char *) direstr.chrs);
	extstr.len = strlen((char *) extstr.chrs);	
    }

    rsltstr.len = 0;

    if((i = UseMenus()) > 0)
    {
        int (*func)(void *, MENUFS *) = (int(*)())use_thg;
        pThing = (THING_HEADER_EXT *) i;
	HoldSiblings();
        i = (func) (pThing->thh_code, &s);
        if(i >= 0)
        {
            restore(buf,  (struct QD_text *) &rsltstr);
            restore(dirs, (struct QD_text *) &direstr);
	    restore(dirs+strlen(dirs), (struct QD_text *) &extstr);	    
        }
        sms_fthg("Menus", -1, NULL, 0, NULL, NULL);	
	RelSiblings();
    } 
    i = (i >= 0) ? strlen(buf) : (unsigned long) -1;
    return i;
}


int Test4Menus(void)
{
    int i;
    
    i = UseMenus();
    if(i > 0)
    {
	sms_fthg ("Menus", -1, NULL, 0, NULL, NULL);
    }
    return (i > 0);
}
#else
int main(void)
{
    char buf[40], dirn[40], ext[40];
    
    while(fputs("File: ", stdout), gets(buf))
    {
	SplitUp(buf, dirn, ext);
	printf("Buf %s\ndirn %s\next %s\n",
	       buf, dirn, ext);
    }
    return 0;
}
#endif
