/*
 * $Log: smagic.c,v $
 * Revision 1.3  1996/12/23 22:33:04  jrh
 * Checkin for 1.62
 *
 * Revision 1.2  1995/11/12  15:29:37  root
 * Baud rates for QXL etc
 *
 * Revision 1.1  1995/09/16  17:22:18  root
 * Initial login under Linux
 *
 * Revision 1.3  1995/04/08  20:53:27  jrh
 * Add Thing functionality
 *
 * Revision 1.2  1995/04/01  00:02:26  jrh
 * Fix resized menu redraw bug
 *
 * Revision 1.1  1995/03/31  21:21:23  jrh
 * Initial revision
 *
 */

static char rcsid[] ="$Id: smagic.c,v 1.3 1996/12/23 22:33:04 jrh Exp $";

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <qdos.h>
#include <qptr.h>

typedef struct mitem
{
    short len;
    char chrs[1];
} MITEM, *PMITEM;

#include "defs.h"

typedef struct
{
    QD_text_t *qtext;
    char skey;
    unsigned char status;
    int retval;
    WM_action_t *action;
    char *sfile;
} SDEF;

extern  int RunScript(char *, short, char *);

void FreeSMenu (PLLIST *pL)
{
    PLLIST p;

    for (p = *pL; p;)
    {
	MITEM *s;
	SDEF *pm;
	LLIST *pd;

	pd = p;
	p = p->next;
	pm = (SDEF *) pd->item;
	s = (PMITEM) pm->qtext;
        xfree (pm->sfile);
	xfree (s);
	xfree (pm);
	xfree (pd);
    }
    *pL = NULL;
}

static AddSMenu (PLLIST * pX, char *mitem, char *mfile, char *mkey)
{
    MITEM *s;
    SDEF * pm;
    LLIST *pl;
    short n;
    
    n  = strlen (mitem);
    s = xmalloc (n+8);
    s->len = n;
    strcpy(s->chrs, mitem);
    pm =  xmalloc (sizeof (SDEF));
    pm->qtext = (QD_text_t *) s;
    pm->status = WSI_AVBL;
    pm->retval = 0;
    pm->action = NULL;
    pm->sfile = mystrdup(mfile);
    
    if(mkey && *mkey)
    {
        char *p;
        for(p = mitem; *p ; p++)
        {
            if(toupper(*p) == toupper(*mkey))
            {
                pm->skey = -(p + 1 - mitem);
                break;
            }
        }
    }
    pl = (PLLIST) xmalloc (sizeof (LLIST));
    pl->item = pm;
    pl->next = NULL;
    ins_list (pX, pl, NULL);
}

static char *MTitle = NULL;
static LLIST *SL = NULL;
static int S_nitem, S_wid;

int BuildSMenu (void)
{
    char *p;
    int n = 0;
    PLLIST pl;
    int fd;
    int i;

    if(*SMenuDat)
    {    
	if(MTitle)
	{
	    xfree(MTitle);
	    MTitle = NULL;
	}
	if(SL)
	{
	    FreeSMenu(&SL);
	}
	
	S_wid = 0;
  
	fd = io_open (SMenuDat, IO_OLD);
	if (fd > 0)
	{
	    char *z, text[128];
	    short first = 1;
	    for (n = 0; ((i = io_fline (fd, -1, text, (short) sizeof (text))), i > 0);)
	    {
		if(*text == '#')
		{
		    continue;
		}
		*(text + i - 1) = '\0';
		if(first)
		{
		    MTitle = mystrdup(text);
		    first = 0;
		    S_wid = strlen(text) + 8;
		}
		else
		{
		    short j;
		    char *p,*p1;
		    int sl;
		    char *mitem, *mfile, *mkey;
		    mitem = mfile = mkey = NULL;
		    for(j = 0, p = text; p1 = strtok(p, "|"); p = NULL,j++)
		    {
			for(;*p1 <= ' ';p1++)
			    ; /* skip white space */
			
                    {
                        char *p2 = p1 + strlen(p1);
                        for (; *p2 <= ' ' && p2 != p1; p2--)
                        {
                            *p2 = 0;
                        }
		    }    
			switch(j)
			{
			  case 0:
                            mitem = p1;
                            break;
			  case 1:
                            mfile = p1;
		            break;
			  case 2:
                            mkey = p1;
		            break;
		    }
		    }
		    if(j > 1)
		    {
			sl = strlen(mitem);
			if(sl > S_wid)
			{
			    S_wid = sl;
			}
			AddSMenu(&SL, mitem, mfile, mkey);
			n++;
                }
		}
	    }
	    io_close(fd);
	}
        S_nitem = n;
    }
    return n;
}
int UserAction(WM_wwork_t *wwk)
{
    int n;
    extern WM_litm_t DD_litm[];

#if 0
    {
        char txt[80];
        sprintf(txt,"S_nitem, S_wid %d %d (%d)", S_nitem, S_wid);
        menu_choice (wwk, txt, 1, 0, "OK");
    }
#endif

    if(S_nitem)
    {
	n = menu (wwk, MTitle, &SL, S_nitem, 50, 50, (S_wid+3)*6, 0, DD_litm, 1);
	if (n >= 0)
	{
	    LLIST *pz;
	    SDEF *pi;
	    int i;
	    char *c, *o;

	    for (pz = SL, i = 0; i < n && pz; i++)
	    {
		pz = pz->next;
	    }
	    pi = (SDEF *) pz->item;
	    c = pi->sfile;
            if(o = strchr(c, ';'))
            {
                *o = '\0';
                o++;
            }
            RunScript(c, 0, o);
	}
    }
    else
    {
	menu_choice (wwk, "No menu items defined", 1, 0, "OK");
    }        
}

